
#include <Wire.h>
#include "BME280.h"

// ピン番号 (standard pinout)
#define PIN_LED1 0
#define PIN_LED2 21
#define PIN_LED3 22
#define PIN_LED4 23
#define PIN_SW2 2
#define PIN_SW31 18
#define PIN_SW32 19
#define PIN_SW33 20
#define PIN_SDCD 14
#define PIN_SDCS 4
#define PIN_RTCINT 11
#define PIN_BNORST 3
#define PIN_BNOINT 10
#define PIN_BNOBOOT 1
#define PIN_CCSWAKE 12
#define PIN_CCSRST 13

BME280 bme280;

void setup() {
  Serial.begin(57600);
  while(!Serial){
    delay(1);
  }

  // ピン初期設定
  pinMode(PIN_LED1, OUTPUT);
  pinMode(PIN_LED2, OUTPUT);
  pinMode(PIN_LED3, OUTPUT);
  pinMode(PIN_LED4, OUTPUT);
  pinMode(PIN_SW2, INPUT_PULLUP);
  pinMode(PIN_SW31, INPUT_PULLUP);
  pinMode(PIN_SW32, INPUT_PULLUP);
  pinMode(PIN_SW33, INPUT_PULLUP);
  pinMode(PIN_SDCD, INPUT_PULLUP);
  digitalWrite(PIN_SDCS, HIGH);
  pinMode(PIN_SDCS, OUTPUT);
  digitalWrite(PIN_BNORST, HIGH);
  pinMode(PIN_BNORST, OUTPUT);
  digitalWrite(PIN_BNOBOOT, HIGH);
  pinMode(PIN_BNOBOOT, OUTPUT);
  digitalWrite(PIN_CCSWAKE, HIGH);
  pinMode(PIN_CCSWAKE, OUTPUT);
  digitalWrite(PIN_CCSRST, HIGH);
  pinMode(PIN_CCSRST, OUTPUT);

  Serial.print(F("\n\n-----------------------\n"));
  Serial.print(F("Program start\n"));

  // BME280初期設定
  if(!bme280.begin(0x76)){
    // 失敗した場合
    Serial.print(F(" BME280 Initialization failure\n"));
    while(1){
      delay(1000);
    }
  }

  // 結果のヘッダー部を表示
  Serial.println(F("Temp[C], Pressure[hPa], Humidity[%]"));
}


void loop() {
  char c[10];
  bme280.forced(true);  // 測定開始
  bme280.readADC();     // 結果を格納
  String t = String(dtostrf(bme280.T, 3, 1, c));
  String p = String(dtostrf(bme280.P, 3, 0, c));
  String h = String(dtostrf(bme280.H, 3, 1, c));
  Serial.println(t +", " + p + ", " + h);
  delay(1000);
}
